/**
 * \file input/identificationpwizreader.cpp
 * \date 17/6/2017
 * \author Olivier Langella
 * \brief read identification files using pwiz library
 */

/*******************************************************************************
* Copyright (c) 2017 Olivier Langella <Olivier.Langella@u-psud.fr>.
*
* This file is part of XTPcpp.
*
*     XTPcpp is free software: you can redistribute it and/or modify
*     it under the terms of the GNU General Public License as published by
*     the Free Software Foundation, either version 3 of the License, or
*     (at your option) any later version.
*
*     XTPcpp is distributed in the hope that it will be useful,
*     but WITHOUT ANY WARRANTY; without even the implied warranty of
*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*     GNU General Public License for more details.
*
*     You should have received a copy of the GNU General Public License
*     along with XTPcpp.  If not, see <http://www.gnu.org/licenses/>.
*
* Contributors:
*     Olivier Langella <Olivier.Langella@u-psud.fr> - initial API and implementation
******************************************************************************/

#include "identificationpwizreader.h"

#include <QDebug>
#include <QSettings>
#include <QFileInfo>
#include <QDir>
#include <QString>
#include <pappsomspp/exception/exceptionnotfound.h>

#include <pwiz/data/identdata/IdentData.hpp>
#include <pwiz/data/identdata/IdentDataFile.hpp>
#include <locale>


pwiz::identdata::IdentDataFile * getPwizIdentDataFile(const QString & filename);


pwiz::identdata::IdentDataFile * getPwizIdentDataFile(const QString & filename) {
    qDebug() << "getPwizIdentDataFile opening file " << filename ;
    std::string env;
    env=setlocale(LC_ALL,"");
    struct lconv * lc = localeconv ();
    qDebug() << " env=" << env.c_str() << " lc->decimal_point " << lc->decimal_point;
    setlocale(LC_ALL,"C");
    //lc = localeconv ();
    //qDebug() << " env=" << localeconv () << " lc->decimal_point " << lc->decimal_point;
    pwiz::identdata::IdentDataFile * dataFile = new pwiz::identdata::IdentDataFile(filename.toStdString());

    setlocale(LC_ALL,env.c_str());

    return dataFile;
}

IdentificationPwizReader::IdentificationPwizReader(const QFileInfo & filename):_identfile(filename) {
    
    _pwiz_ident_data_file = getPwizIdentDataFile(filename.absoluteFilePath());
}

const QFileInfo & IdentificationPwizReader::getMsrunQFileInfo() const {
    //qDebug() << "IdentificationPwizReader::getMsrunQFileInfo begin" <<  _pwiz_ident_data_file->analysisSampleCollection.size();
        return _identfile;
    }
